static char* sccs_buttons_c = "@(#)buttons.c	1.220/11/92";

#include "gen.h"
#include "widgets.h"


extern void	CreateSubButton PROTO((Info*, int, int, char*));
extern	void	CreateMainMenuButton PROTO((Info*, int, int, char*, char*));
static	void	CreateDefaultSubButton PROTO((int, char*, int));
extern  void    Quit PROTO((Widget,XtPointer,XtPointer)),
		SingleAction PROTO((Widget,XtPointer,XtPointer)),
		MultiAction PROTO((Widget,XtPointer,XtPointer)),
                ReadALine PROTO((FILE*,char **)),
                Source PROTO((Widget,XtPointer,XtPointer));
extern	void	delay PROTO((Widget,XEvent *,String *,Cardinal *));

static  void    SetButton PROTO((int,char *,int));
static  void    SetSubMenuButton PROTO((int,char *,int));
static	void	ErrorMessage PROTO((int, char*, char*));
static	void	CreatePopupShell PROTO((int));
extern	void	CreateSubMenuButton PROTO((int, char *, int, char*));
extern	void	DefaultButtons PROTO((Info *,int));
extern	void    ConvertTitle PROTO((char*));


extern void
CreateSubButton(data, button_no, is_icon, label)
Info	*data;
int		button_no;
int		is_icon;
char	*label;
{
	char	w_buffer[80];

	/* create main menu button that will popup sub menu */
	(void) sprintf(w_buffer, "action%d", button_no);
	action[button_no] = XtVaCreateManagedWidget(
			w_buffer,
			xmCascadeButtonWidgetClass,
			menuBar,
			NULL);

	SetButton(is_icon, label, button_no);
	CreatePopupShell(button_no);
	XtVaSetValues(action[button_no], XmNsubMenuId, popup_shell, NULL);
}


extern void
CreateMainMenuButton(data, button_no, is_icon, label, command)
Info	*data;
int	button_no;
int	is_icon;
char	*label;
char	*command;
{
		char	w_buffer[80];

		(void) sprintf(w_buffer, "action%d", button_no);

		action[button_no] = XtVaCreateManagedWidget(
			w_buffer, 	     		/* widget name */	
			xmCascadeButtonWidgetClass,  	/* widget class */
			menuBar,            		/* parent widget */
			NULL);	   /* terminate varargs list */

		SetButton(is_icon, label, button_no);

		/* add callback for this button */
		if((is_icon == TEXT) || (is_icon == ICON) ||
			(is_icon == PIXMAP))
			XtAddCallback(action[button_no],
				XmNactivateCallback,
				SingleAction,
				command);
		else
			XtAddCallback(action[button_no],
				XmNactivateCallback,
				MultiAction,
				command);
}

static	void
SetButton(is_icon,icon,button_num)
int	is_icon;
char	*icon;
int	button_num;
{
	int		screen;
	int		ErrorStatus;
	Pixel		foreground, background;
	Display*	display;
	XpmAttributes	attributes;
	Pixmap		mask;
	XmString	label;

	XtVaGetValues(action[button_num], XmNforeground, &foreground, NULL);
	XtVaGetValues(action[button_num], XmNbackground, &background, NULL);

	label = XmStringLtoRCreate (icon, XmSTRING_DEFAULT_CHARSET);
	/* if button title is a string then */
	if((is_icon == TEXT) || (is_icon == TEXTPLUS))
	{
		XtVaSetValues(
			action[button_num],
			XmNlabelString, label,
			NULL);
	}
	/* if button title is a bitmap then */
	if((is_icon == ICON) || (is_icon == ICONPLUS))	
	{
		pix = XmGetPixmap(
			XtScreen(action[button_num]),
			icon,
			foreground, background);

		if(pix == XmUNSPECIFIED_PIXMAP)
		{
			XtVaSetValues(
				action[button_num],
				XmNlabelString, label,
				NULL);

			fprintf(stderr, 
				"\ncannot find bitmap file: %s\n", icon);
			fprintf(stderr, 
			"\nHave you set XBMLANGPATH environment variable?\n");
		}
		else
		{
			pix2 = XmGetPixmap(
				XtScreen(action[button_num]),
				icon,
				background, foreground);

			XtVaSetValues(
				action[button_num],
				XmNlabelType,
				XmPIXMAP,
				XmNlabelPixmap,
				pix,
				XmNlabelType,
				XmPIXMAP,
				XmNlabelInsensitivePixmap,
				pix2,
				NULL);
		}
	}

	if((is_icon == PIXMAP) || (is_icon == PIXMAPPLUS))	
	{
		display = XtDisplay(action[button_num]);
		screen = XRootWindowOfScreen(XtScreen(action[button_num]));
		c_pix.attributes.valuemask = XpmReturnExtensions;

		ErrorStatus = XpmReadFileToPixmap(
			display,
			screen,
			icon, &c_pix.pixmap, &c_pix.mask, 
			&c_pix.attributes);

		ErrorMessage(ErrorStatus, "Read", icon);
		if(ErrorStatus == XpmFileInvalid)
		{
			if(c_pix.pixmap)
				XFreePixmap(display, c_pix.pixmap);
			if(c_pix.mask)
				XFreePixmap(display, c_pix.mask);
			XpmFreeAttributes(&c_pix.attributes);
		}
		if(ErrorStatus != XpmSuccess)
		{
			XtVaSetValues(
				action[button_num],
				XmNlabelString, label,
				NULL);
		}
		else
		{
			XtVaSetValues(
				action[button_num],
				XmNlabelType,
				XmPIXMAP,
				XmNlabelPixmap,
				c_pix.pixmap,
				XmNlabelType,
				XmPIXMAP,
				XmNlabelInsensitivePixmap,
				c_pix.pixmap,
				NULL);
		}
	}
	XmStringFree(label);
}

static	void
SetSubMenuButton(is_icon,icon,button_num)
int	is_icon;
char	*icon;
int	button_num;
{
	int             screen;
	int             ErrorStatus;
	Display*        display;
	XpmAttributes   attributes;
	Pixmap          mask;
	Pixel		foreground, background;
	XmString	label;

	XtVaGetValues(sub_action[button_num], XmNforeground, &foreground, NULL);
	XtVaGetValues(sub_action[button_num], XmNbackground, &background, NULL);

	label = XmStringLtoRCreate (icon, XmSTRING_DEFAULT_CHARSET);
	/* if button title is a string then */
	if((is_icon == TEXT) || (is_icon == TEXTPLUS))
	{
		XtVaSetValues(
			sub_action[button_num],
			XmNlabelString, label,
			NULL);
	}

	/* if button title is a bitmap then */
	else if((is_icon == ICON) || (is_icon == ICONPLUS))	
	{
		pix = XmGetPixmap(
			XtScreen(sub_action[button_num]),
			icon,
			foreground, background);

		if(pix == XmUNSPECIFIED_PIXMAP)
                {
                        XtVaSetValues(
                                sub_action[button_num],
                                XmNlabelString, label,
                                NULL);

                        fprintf(stderr, 
                                "\ncannot find bitmap file: %s\n", icon);
                        fprintf(stderr, 
                        "\nHave you set XBMLANGPATH environment variable?\n");
                }
		else
		{
			pix2 = XmGetPixmap(
				XtScreen(sub_action[button_num]),
				icon,
				background, foreground);

			XtVaSetValues(
				sub_action[button_num],
				XmNlabelType,
				XmPIXMAP,
				XmNlabelPixmap,
				pix,
				XmNlabelType,
				XmPIXMAP,
				XmNlabelInsensitivePixmap,
				pix2,
				NULL);
		}

	}
        else if((is_icon == PIXMAP) || (is_icon == PIXMAPPLUS))      
        {
                display = XtDisplay(action[button_num]);
                screen = XRootWindowOfScreen(XtScreen(sub_action[button_num]));
		c_pix.attributes.valuemask = XpmReturnExtensions;

		ErrorStatus = XpmReadFileToPixmap(
			display,
			screen,
			icon, &c_pix.pixmap, &c_pix.mask, 
			&c_pix.attributes);

		ErrorMessage(ErrorStatus, "Read", icon);
		if(ErrorStatus == XpmFileInvalid)
		{
			if(c_pix.pixmap)
				XFreePixmap(display, c_pix.pixmap);
			if(c_pix.mask)
				XFreePixmap(display, c_pix.mask);
			XpmFreeAttributes(&c_pix.attributes);
		}
                if(ErrorStatus != XpmSuccess)
                {
                        XtVaSetValues(
                                sub_action[button_num],
                                XmNlabelString, label,
                                NULL);
                }
                else
                {
                        XtVaSetValues(
                                sub_action[button_num],
                                XmNlabelType,
                                XmPIXMAP,
                                XmNlabelPixmap,
                                c_pix.pixmap,
                                XmNlabelType,
                                XmPIXMAP,
                                XmNlabelInsensitivePixmap,
                                c_pix.pixmap,
                                NULL);
                }
        }
	XmStringFree(label);
}

static	void
CreatePopupShell(shell_no)
int	shell_no;
{

	popup_shell = XmCreatePulldownMenu(
			menuBar,
			"popup_shell",
			NULL,
			0);
}

static	void
CreateDefaultSubButton(key_word,button_name,button_num)
int     key_word;
char    *button_name;
int     button_num;
{
        char    w_buffer[80];

        (void) sprintf(w_buffer,"sub_action%d",button_num);
        sub_action[button_num] = XtVaCreateWidget(
                        w_buffer,
                        xmPushButtonWidgetClass,
                        popup_shell,
                        NULL);

        SetSubMenuButton(key_word,button_name,button_num); 
	XtManageChild(sub_action[button_num]);
}

extern	void
CreateSubMenuButton(key_word, button_name, button_num, command)
int	key_word;
char	*button_name;
int	button_num;
char	*command;
{
	char	w_buffer[80];

	(void) sprintf(w_buffer,"sub_action%d", button_num);
	sub_action[button_num] = XtVaCreateManagedWidget(
			w_buffer,
			xmPushButtonWidgetClass,
			popup_shell,
			NULL);

	SetSubMenuButton(key_word, button_name, button_num); 

	if((key_word == TEXT) || (key_word == ICON) || (key_word == PIXMAP))
		XtAddCallback(sub_action[button_num],
			XmNactivateCallback,SingleAction,command);
	else
		XtAddCallback(sub_action[button_num],
			XmNactivateCallback,MultiAction,command);
}

extern	void
delay(w,event,params,num_params)
Widget  w;
XEvent  *event; /* unused */
String  *params;
Cardinal        *num_params;
{
	(void) sleep(1);
}

extern	void
DefaultButtons(data,last_button)
Info	*data;
int	last_button;
{
	int	string_length;
	char	w_buffer[80];
	char	*button_label;
	char	*edit_file, *h_file;

	/* create default sub menu which will contain source, edit & quit */
	/* buttons.  Default menu button is called Manage  */

	button_label = malloc(80);
	if(button_label == NULL)
	{
		printf(stderr,"malloc out of memory\n");
		exit(1);
	}
	(void) sprintf(w_buffer,"action%d",last_button);
	action[last_button] = XtVaCreateManagedWidget(
			w_buffer,
			xmCascadeButtonWidgetClass,
			menuBar,
			NULL);

	strcpy(button_label, "Edit\nIcons");
	ConvertTitle(button_label);
	SetButton(TEXT, button_label,last_button); 

	/* create popup shell */
	CreatePopupShell(last_button);
	XtVaSetValues(action[last_button], XmNsubMenuId, popup_shell, NULL);

	strcpy(button_label, "\n Source\n");
	ConvertTitle(button_label);
	CreateDefaultSubButton(TEXT, button_label, 0);

	XtAddCallback(sub_action[0], XmNactivateCallback, Source, data);

	strcpy(button_label, "\nEdit\n.briconsrc");
	ConvertTitle(button_label);
	CreateDefaultSubButton(TEXT, button_label, 1);

	string_length = strlen(data->editor);
	string_length += strlen(data->icon_file);
	if((edit_file = malloc(string_length + 1)) == NULL)
	{
		(void) fprintf(stderr,"ERROR: out of memory for string edit_file.  In function CreateButtons.\n");
		exit(1);
	}
	strcpy(edit_file,data->editor);
	strcat(edit_file,data->icon_file);

	XtAddCallback(sub_action[1],XmNactivateCallback,SingleAction,edit_file);

	strcpy(button_label, "\n HELP!\n");
	ConvertTitle(button_label);
	CreateDefaultSubButton(TEXT,button_label, 2);

	string_length = 0;
	string_length = strlen(FORMATTER);
	string_length += strlen(HELP_VIEWER);
	string_length += strlen(data->help_file);
	if((h_file = malloc(string_length +1)) == NULL)
	{
		(void) fprintf(stderr,"ERROR: out of memory for string edit_file.  In function CreateButtons.\n");
		exit(1);
	}
	strcpy(h_file,FORMATTER);
	strcat(h_file,data->help_file);
	strcat(h_file,HELP_VIEWER);
	XtAddCallback(sub_action[2],XmNactivateCallback,SingleAction,h_file);

	strcpy(button_label, "\n QUIT\n");
	ConvertTitle(button_label);
	CreateDefaultSubButton(TEXT, button_label, 3);

	XtAddCallback(sub_action[3],XmNactivateCallback,Quit,NULL);
}

static	void
ErrorMessage(ErrorStatus, tag, file)
int	ErrorStatus;
char	*tag;
char	*file;
{
	char *error = NULL;
	char *warning = NULL;

	switch (ErrorStatus) 
	{
		case XpmSuccess:
			return;
		case XpmColorError:
			warning = "Could not parse or alloc requested color";
			break;
		case XpmOpenFailed:
			warning = "Cannot open file";
			break;
		case XpmFileInvalid:
			warning = "Invalid XPM file";
			break;
		case XpmNoMemory:
			error = "Not enough memory";
			break;
		case XpmColorFailed:
			warning = "Failed to parse or alloc some color";
			break;
	}
	if (warning)
		fprintf(stderr, "\n%s Xpm Warning: %s: %s\n", tag, 
			warning, file);

	if (error) 
	{
		fprintf(stderr, "\n%s Xpm Warning: %s: %s\n", tag, 
			warning, file);
		exit(1);
	}
}

